
// Party Scope V1.0
// Fredric V. Echols (AKA [BadDog])

#define BASE_PORT  0x220
#define RESET_PORT 0x226
#define WRITE_PORT 0x22C
#define READ_PORT  0x22A
#define AVAIL_PORT 0x22E
#define DATA_READY 0x080
#define DATA_REQ 0x20

#include <go32.h>
#include <dpmi.h>
#include <sys/movedata.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>
#include <vgalib.c>

void main (void)
	{
	int x=0,devide=1,temp=0,up_wave=0;

	int y_data[321];
	int velocity[321];
	int position[321];
	int in_use[321];

	Set_Mode(VGA);

	srandom(time());

	for (x=0; x!=319; x++)
		{
		y_data[x]=0;
		velocity[x]=0;
		position[x]=200;
		in_use[x]=0;
		}

	for (x=1; x<256; x++)
		 {
		 temp=random();
		 Set_RGB(x,temp,temp,temp);
		 }

	for (x=0; x<250; x++) Set_RGB(random(),0,random(),0);
	Set_RGB(0,0,0,0);

	outp(WRITE_PORT,DATA_REQ); /* Request data */

	while (!kbhit())
		{
		up_wave=1; /* By default RAISE the wave. */

		for (x=0; x!=319; x++)
			{
			if (x>0 && x<318) Put_Y_Line(x+1,y_data[x]+100,y_data[x+1]+100,0);

			while (!(inp(AVAIL_PORT) & DATA_READY)); /* Wait for data */

			y_data[x]+=(inp(READ_PORT)-128)/devide; /* Get data */

			outp(WRITE_PORT,DATA_REQ); /* Request data */

			/* Do graphics while waiting... :) */
			/* (i.e. On my system line drawing is *TRANSPERENT* :) */
         /* (i.i.e. I can draw a line LONG before I need to get the data.) */

			if (y_data[x]>0) y_data[x]--;
				else if (y_data[x]<0) y_data[x]++;

			if (y_data[x]>200 || y_data[x]<(-200))
				{
				for (temp=0; temp<319; temp++)
					{
					Put_Y_Line(temp+1,y_data[temp]+100,y_data[temp+1]+100,0);
					y_data[temp]=0;
					}
				devide++;
				}

			if (y_data[x]) up_wave=0; /* If wave is *NOT* level then reset */
											  /* the up_wave flag */
											  /* (otherwise we raise the wave) */

			if (x>1) Put_Y_Line(x,y_data[x]+100,y_data[x-1]+100,x);

			/* Bouncies */

			Put_Pixel(x,position[x],0);

			if (in_use[x])
				{
				velocity[x]++;
				position[x]+=velocity[x];

				if (position[x]>=200)
					{
					position[x]=200;
					in_use[x]=0;
					velocity[x]=0;
					}
				}
				else if (y_data[x]<0)
					{
					velocity[x]=(y_data[x]>>1); // Devide by 2
					in_use[x]=1;
					}

			Put_Pixel(x,position[x],x);

			/* End Bouncies */
			}
		if (up_wave) if (devide>1) devide--;
		}

	Set_Mode(TEXT);
	exit(0);
	}


