
#define VGA 0x13
#define TEXT 0x03

/* Sets the current hardware mode */
void Set_Mode (short mode)
	{
	__dpmi_regs regs;
	regs.x.ax = mode;
	__dpmi_int(0x10,&regs);
	}

/* Put a pixel in the BUFFER */
/* DOES NOT CHECK X COORDS! */
void Put_Pixel (short x, short y, unsigned char color)
	{
	if (y>0 && y<200) _farpokeb(_dos_ds,0xA0000+(x+(y<<6)+(y<<8)),color);
	}

void Put_Y_Line (int x, int y, int y2, unsigned char color)
	{
	int c,c2;

	if (y2<y) // Flip coords
		{
		c=y;
		y=y2;
		y2=c;
		}

	if (y<0) y=0;
	if (y>199) return; // Nothing to draw!
	if (y2<0) return;  //   "      "   "
	if (y2>199) y2=199;

	_farsetsel(_dos_ds); /* Set the DOS Data Segment */

	c2=0xA0000+(y<<6)+(y<<8)+x; // compute address (The slow part)

	if (y2==y)
		{
		_farnspokeb(c2, color); /* "Put_Pixel" */
		return;
		}

	for (c=y; c<y2; c++)
		{
		_farnspokeb(c2, color); /* "Put_Pixel" */
		c2+=320;
		}
	}

/* Sets RGB color values in the VGA palette*/
void Set_RGB (unsigned char color, unsigned char r, unsigned char g,
				  unsigned char b)
	 {
	 outp(0x3c8, color);
	 outp(0x3c9, r);
	 outp(0x3c9, g);
	 outp(0x3c9, b);
	 }

